#!/usr/bin/python
#-*- coding=utf-8 -*-
#---------------------------------------------------------------------
#- @File     : fsview.py 
#- @Author   : Shizhengxian, Jiajiandong( NFS-china)
#- @DateTime : Mon, 11 Aug 2014 17:20:34 CST
#- @CopyRight: The Security Tools Group( NFS-china)
#-
#- @Brief : 该文件为文件共享的另外一个界面，主要功能包含：
#-        : 1. 查看局域网内正在工作的计算机.
#-        : 2. 列出某个节点的共享列表.
#-        : 3. 列出本地节点的共享里表.
#-        : 4. 浏览和下载共享目录和文件.
#---------------------------------------------------------------------

from gi.repository import Gtk, Gdk, GLib, GdkPixbuf, GObject
from gettext import gettext as _
import fsop,os

def init_all():
    #buidler
    global builder
    builder = Gtk.Builder()
    builder.add_from_file("/usr/lib/f.share/check.glade")
    #builder.add_from_file("check.glade")

    #main_window
    main_win = builder.get_object("window1")
    main_win.set_default_size(800,600)
    main_win.set_default_icon_from_file("/usr/lib/f.share/icon/HOST.png")
    main_win.set_title("\xe5\xb1\x80\xe5\x9f\x9f\xe7\xbd\x91\xe5\x85\xb1\xe4\xba\xab\xe6\xb5\x8f\xe8\xa7\x88")
    main_win.show()
    main_win.connect('destroy', quit)

    #button
    backbtn = builder.get_object("backbtn")
    backbtn.connect('clicked',backbtn_clicked)

    global addbtn,delbtn
    addbtn = builder.get_object("addbtn")
    addbtn.hide()
    addbtn.connect('clicked',addbtn_clicked)

    delbtn = builder.get_object("delbtn")
    delbtn.hide()
    delbtn.connect('clicked',delbtn_clicked)

    #menubar
    imagemenuitem5 = builder.get_object("imagemenuitem5")
    imagemenuitem5.connect('activate',quit)

    imagemenuitem10 = builder.get_object("imagemenuitem10")
    imagemenuitem10.connect('activate',about_callback) ##

    #global val
    global current_dir, current_node, mnt_dir, mnt_list, current_remote_project,select_rows,activate_node
    activate_node = ""
    select_rows = 2
    current_dir = '.'
    current_node = "127.0.0.1"
    mnt_dir = "/mnt/tmp"
    mnt_list = []
    current_remote_project = ""
    global add_local_dir
    add_local_dir = ''
    global name,pwd
    name = ''
    pwd = ''

    #scrolledwindow
    global scrolledwindow1
    scrolledwindow1 = builder.get_object("scrolledwindow1")

    #iconview-host-net
    global iconview, hosticon, neticon, diricon
    iconview = builder.get_object("iconview1")
    hosticon = GdkPixbuf.Pixbuf.new_from_file_at_size(str("/usr/lib/f.share/icon/HOST.png"),70,70)
    neticon = GdkPixbuf.Pixbuf.new_from_file_at_size(str("/usr/lib/f.share/icon/NET.png"),70,70)
    diricon = GdkPixbuf.Pixbuf.new_from_file_at_size(str("/usr/lib/f.share/icon/dir.jpg"),70,50)
    #hosticon = GdkPixbuf.Pixbuf.new_from_file_at_size(str("HOST.png"),70,70)
    #neticon = GdkPixbuf.Pixbuf.new_from_file_at_size(str("NET.png"),70,70)
    #diricon = GdkPixbuf.Pixbuf.new_from_file_at_size(str("dir.jpg"),70,50)
    iconlist = Gtk.ListStore(str,GdkPixbuf.Pixbuf)
    iconlist.append(['\xe6\x9c\xac\xe5\x9c\xb0',hosticon])  #host
    iconlist.append(['\xe7\xbd\x91\xe7\xbb\x9c',neticon])    #net
    iconview.set_model(iconlist)
    iconview.set_text_column(0)
    iconview.set_pixbuf_column(1)
    iconview.set_row_spacing(10)
    iconview.connect('selection_changed',iconview_selection_changed)


    #treeview for host share list
    global treeview, treelist,popup_menu
    treelist = Gtk.ListStore(str,str,str)
    treeview = Gtk.TreeView(treelist)
    trcolumn1 = Gtk.TreeViewColumn(('\xe5\x85\xb1\xe4\xba\xab\xe7\x9b\xae\xe5\xbd\x95'))
    trcolumn2 = Gtk.TreeViewColumn(('\xe5\x85\xb1\xe4\xba\xab\xe8\xb7\xaf\xe5\xbe\x84'))
    trcolumn3 = Gtk.TreeViewColumn(('\xe5\x85\xb1\xe4\xba\xab\xe6\x8f\x8f\xe8\xbf\xb0'))
    cell1 = Gtk.CellRendererText()
    cell2 = Gtk.CellRendererText()
    cell3 = Gtk.CellRendererText()
    trcolumn1.pack_start(cell1,True)
    trcolumn2.pack_start(cell2,True)
    trcolumn3.pack_start(cell3,True)
    trcolumn1.set_attributes(cell1, text=0)
    trcolumn2.set_attributes(cell2, text=1)
    trcolumn3.set_attributes(cell3, text=2)
    treeview.append_column(trcolumn1)
    treeview.append_column(trcolumn2)
    treeview.append_column(trcolumn3)
    treeview.connect('row-activated',treeview_row_activated)
    treeview.connect('button_press_event',treeview_right_btn)
    treeview.connect('cursor-changed',cursor_changed)

    global popup_menu_add, popup_menu_del
    popup_menu = builder.get_object("menu4")
    popup_menu_add = Gtk.MenuItem("\xe6\xb7\xbb\xe5\x8a\xa0\xe6\x9c\xac\xe5\x9c\xb0\xe5\x85\xb1\xe4\xba\xab")
    popup_menu_add.connect('activate',addbtn_clicked)
    popup_menu_add.show()
    popup_menu.append(popup_menu_add)
    popup_menu_del = Gtk.MenuItem("\xe5\x88\xa0\xe9\x99\xa4\xe6\x9c\xac\xe5\x9c\xb0\xe5\x85\xb1\xe4\xba\xab")
    popup_menu_del.connect('activate',delbtn_clicked)
    popup_menu_del.show()
    popup_menu.append(popup_menu_del)
    

    #iconview for working_nodes
    global iconview1, treelist1
    iconview1 = Gtk.IconView()
    treelist1 = Gtk.ListStore(str,GdkPixbuf.Pixbuf)
    iconview1 = Gtk.IconView(treelist1)
    iconview1.set_text_column(0)
    iconview1.set_pixbuf_column(1)
    iconview1.set_item_width(15)
    iconview1.set_row_spacing(5)
    iconview1.set_column_spacing(10)
    iconview1.connect('selection_changed',iconview1_selection_changed)
    iconview1.connect('item-activated',iconview1_item_activated)


    #iconview for node_share.project
    global iconview2, treelist2
    iconview2 = Gtk.IconView()
    treelist2 = Gtk.ListStore(str,GdkPixbuf.Pixbuf)
    iconview2 = Gtk.IconView(treelist2)
    iconview2.set_text_column(0)
    iconview2.set_pixbuf_column(1)
    iconview2.set_item_width(10)
    iconview2.set_row_spacing(10)
    iconview2.set_column_spacing(10)
    iconview2.connect('selection_changed',iconview2_selection_changed)
    iconview2.connect('item-activated',iconview2_item_activated)

    #login ui
    #builder.add_from_file("login.glade")

    #essagedialog2
    global messagedialog2
    messagedialog2 = Gtk.MessageDialog(None,0,Gtk.MessageType.INFO,(Gtk.ButtonsType.OK),None)
    messagedialog2.set_default_size(250,180)

#function

def about_callback( w):
    dlg = Gtk.AboutDialog()
    dlg.set_title(_("\xe5\x85\xb3\xe4\xba\x8e"))
    dlg.set_program_name(_("\xe5\xb1\x80\xe5\x9f\x9f\xe7\xbd\x91\xe5\x85\xb1\xe4\xba\xab\xe6\xb5\x8f\xe8\xa7\x88"))
    try:
        gpl = "\xe7\x89\x88\xe6\x9d\x83\xe6\x89\x80\xe6\x9c\x89:\xe4\xb8\xad\xe7\xa7\x91\xe6\x96\xb9\xe5\xbe\xb7"
        dlg.set_license(gpl)
    except Exception, detail:
        print detail

    dlg.set_authors(["Jiandong Jia <jiandong@nfschina.com>", "Zhengxian Shi <zhengxian@nfschina.com>"])
    dlg.set_icon_from_file("/usr/lib/f.share/icon/HOST.png")
    dlg.set_logo(GdkPixbuf.Pixbuf.new_from_file_at_size(str("/usr/lib/f.share/icon/HOST.png"),70,70))
    def close(w, res):
        w.hide()
    dlg.connect("response", close)
    dlg.show()




def login_cancel(widget) :
    namentry.set_text("")
    pwdentry.set_text("")
    logind.hide()
#    logind.destroy()

def login_sure(widget):
    global name,pwd
    name = namentry.get_text()
    pwd = pwdentry.get_text()
    logind.destroy()
    #logind.hide()
    remote_shares = fsop.ls_remote_shares(activate_node,name,pwd)
    if remote_shares == 2 :
        print "wrong name or pwd"
        messagedialog2.format_secondary_text('\xe7\x94\xa8\xe6\x88\xb7\xe5\x90\x8d\xe6\x88\x96\xe5\xaf\x86\xe7\xa0\x81\xe9\x94\x99\xe8\xaf\xaf')
        messagedialog2.connect('response',suremg2_response)
        messagedialog2.show()
    elif remote_shares == 3 :
        print "NT_STATUS_ACCESS_DENIED"
        messagedialog2.format_secondary_text('\xe7\x94\xa8\xe6\x88\xb7\xe5\x90\x8d\xe6\x88\x96\xe5\xaf\x86\xe7\xa0\x81\xe9\x94\x99\xe8\xaf\xaf')
        messagedialog2.connect('response',suremg2_response)
        messagedialog2.show()
    elif remote_shares == [] and remote_shares != 2 and remote_shares != 3 :
        print "share return == []"
        messagedialog2.format_secondary_text('\xe8\xaf\xa5\xe8\xae\xa1\xe7\xae\x97\xe6\x9c\xba\xe6\xb2\xa1\xe6\x9c\x89\xe5\x85\xb1\xe4\xba\xab\xe9\xa1\xb9\xe7\x9b\xae')
        messagedialog2.connect('response',suremg2_response)
        messagedialog2.show()
    elif remote_shares != [] and remote_shares != 2 :
        scrolledwindow1.remove(iconview1)
        treelist2.clear()
        for remote_share in remote_shares :
            print remote_share
            treelist2.append(['%s'%remote_share['share_name'],diricon])
        scrolledwindow1.add(iconview2)
        iconview2.show()

def suremg2_response(dialog,response_id) :
    messagedialog2 = dialog
    messagedialog2.hide()


def treeview_right_btn(widget, event) :
    global treeview,current_dir,select_rows,popup_menu_add,popup_menu_del
    select_rows = 0    
    if select_rows == 1 :
        popup_menu_add.set_sensitive(False)
        popup_menu_del.set_sensitive(True)
    else :
        popup_menu_add.set_sensitive(True)
        popup_menu_del.set_sensitive(False)
    if event.type == Gdk.EventType.BUTTON_PRESS and event.button == 3:
        print "fucution::treeview_right_btn==3"
        treeview.get_selection().unselect_all()
        current_dir = ""
        popup_menu.popup(None, None, None, None, event.button, event.time)
        tree, iter = treeview.get_selection().get_selected_rows()
        iter.reverse()
        for item in iter :
            print ""
        treeview.get_selection().select_path(tree.get_value(tree.get_iter(item),0))
        return True
    if event.type == Gdk.EventType.BUTTON_PRESS and event.button == 1:
        print "fucution::treeview_right_btn==1"
        treeview.get_selection().unselect_all()
        current_dir = ""
        select_rows = 0

def backbtn_clicked(backbtn) :
    print "function::backbtn_clicked"
    if scrolledwindow1.get_children()[0] != None and scrolledwindow1.get_children()[0] == iconview2 :
        scrolledwindow1.remove(scrolledwindow1.get_children()[0])
        treelist1.clear() #clean net treelist
        working_nodes = fsop.ls_working_nodes()
        print working_nodes
        for working_node in working_nodes :
            treelist1.append(['%s'%working_node['host'],neticon])
        scrolledwindow1.add(iconview1)
        iconview1.show()

def addbtn_clicked(addbtn) :
    print "function::addbtn_clicked"
    filechooser = Gtk.FileChooserDialog("\xe9\x80\x89\xe6\x8b\xa9\xe4\xb8\x80\xe4\xb8\xaa\xe6\x96\x87\xe4\xbb\xb6\xe5\xa4\xb9", None,Gtk.FileChooserAction.SELECT_FOLDER,
                                            (Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL,
                                            Gtk.STOCK_OPEN, Gtk.ResponseType.ACCEPT))
    filechooser.set_modal(True)
    filechooser.connect('response',open_response)
    filechooser.show()

def open_response(dialog,response_id) :
    global add_local_dir
    filechooser = dialog
    if response_id == Gtk.ResponseType.ACCEPT:
        tmp_add_local_dir = filechooser.get_filename()
        tadd_local_dir = tmp_add_local_dir.replace(' ','//@//')
        add_local_dir = tadd_local_dir+"/"
        print "opened: " + filechooser.get_filename()
        messagedialog1 = Gtk.MessageDialog(None,0,Gtk.MessageType.INFO,(Gtk.ButtonsType.OK),None)
        messagedialog1.set_default_size(250,180)
        messagedialog1.format_secondary_text('\xe6\x96\x87\xe4\xbb\xb6\xe5\x85\xb1\xe4\xba\xab')
        messagedialog1.format_secondary_text('\xe6\x96\x87\xe4\xbb\xb6\xe5\x85\xb1\xe4\xba\xab')
        box = messagedialog1.get_content_area()
        Label = Gtk.Label(tmp_add_local_dir+'\xe5\xb0\x86\xe8\xa2\xab\xe5\x85\xb1\xe4\xba\xab')
        box.add(Label)
        messagedialog1.connect('response',suremg_response)
        messagedialog1.show_all()
    elif response_id == Gtk.ResponseType.CANCEL :
        print "cancelled: FileChooserAction.CANCEL"
    filechooser.destroy()

def suremg_response(dialog,response_id) :
    messagedialog1 = dialog
    global add_local_dir
    if response_id == Gtk.ResponseType.OK :
        print "share dir "+add_local_dir
        ret = fsop.set_share_state(add_local_dir)
        if ret :
            print "share success"
        else :
            print "fail to share "
    if scrolledwindow1.get_children() :
        scrolledwindow1.remove(scrolledwindow1.get_children()[0])
    treelist.clear() #clean host treelist
    local_shares = fsop.ls_local_shares()
    for local_share in local_shares :
        treelist.append([local_share['share_name'],local_share['path'],local_share['comment']])
    scrolledwindow1.add(treeview)
    messagedialog1.destroy()

def delbtn_clicked(delbtn) :
    print "function::delbtn_clicked"
    global current_dir
    if current_dir != "" :
        print current_dir
        ret = fsop.clear_share_state(current_dir)
        if ret :
            print "del success"
        else :
            print "del fail"
    if scrolledwindow1.get_children() :
        scrolledwindow1.remove(scrolledwindow1.get_children()[0])
    treelist.clear() #clean host treelist
    local_shares = fsop.ls_local_shares()
    for local_share in local_shares :
        treelist.append([local_share['share_name'],local_share['path'],local_share['comment']])
    scrolledwindow1.add(treeview)
    current_dir = ""

    #iconview for choose host or net
def iconview_selection_changed(iconview) :
    print "function::iconview_selection_changed(i1)"
    global current_dir
    current_dir = ""
    addbtn.hide()
    delbtn.hide()
    ivmodel = iconview.get_model()
    path = iconview.get_selected_items()[0]
    item = iconview.get_item_row(path)
    itemname = ivmodel[item][0]

    if scrolledwindow1.get_children() :
        scrolledwindow1.remove(scrolledwindow1.get_children()[0])

    if itemname == "\xe6\x9c\xac\xe5\x9c\xb0" : #host
        treelist.clear() #clean host treelist
        local_shares = fsop.ls_local_shares()
        for local_share in local_shares :
            treelist.append([local_share['share_name'],local_share['path'],local_share['comment']])
        scrolledwindow1.add(treeview)
        treeview.show()

    if itemname == "\xe7\xbd\x91\xe7\xbb\x9c" : #net
        treelist1.clear() #clean net treelist
        working_nodes = fsop.ls_working_nodes()
        print working_nodes
        for working_node in working_nodes :
            treelist1.append(['%s'%working_node['host'],neticon])
        scrolledwindow1.add(iconview1)
        iconview1.show()

    #treeview for get current_dir or open current_dir
def cursor_changed(widget) :
    print "function::cursor_changed"
    global current_dir,select_rows
    select_rows = 0
    selectionf = treeview.get_selection()
    if selectionf :
        tree, iter = selectionf.get_selected_rows()
    select_rows = len(iter)
    if select_rows == 1 :
        popup_menu_add.set_sensitive(False)
        popup_menu_del.set_sensitive(True)
    else :
        popup_menu_add.set_sensitive(True)
        popup_menu_del.set_sensitive(False)
    print "total_rows : " + str(select_rows)
    iter.reverse()
    print iter
    for item in iter :
        current_dir = tree.get_value(tree.get_iter(item),1)
        print "treeview-changed::"+ current_dir

def treeview_row_activated(treeview, path, item) :
    print "function::treeview_row_activated(t,p,i)"
    global current_dir
    entry_dir = current_dir
    current_dir = entry_dir.replace(' ','\ ')
    open_cmd = 'gnome-open ' + current_dir
    os.system(open_cmd)

    #iconview1 for get current_node or get&show share project of current_node
def iconview1_selection_changed(iconview1) :
    print "function::iconview1_selection_changed(i1)"
    global current_node
    iv1model = iconview1.get_model()
    path = iconview1.get_selected_items()[0]
    current_node = iv1model[path][0]
    print current_node

def iconview1_item_activated(iconview1, item) :
    print "function::iconview1_item_activated(i,i)"
    
    global activate_node
    iv1model = iconview1.get_model()
    activate_node = iv1model[item][0]

    global logind
    builder.add_from_file("/usr/lib/f.share/login.glade")
    logind = builder.get_object("window2")
    logind.set_resizable(False)
    logind.connect('destroy',login_cancel)

    global namentry, pwdentry
    namentry = builder.get_object("entry1")
    pwdentry = builder.get_object("entry2")
    namentry.set_text("")
    pwdentry.set_text("")

    loginsure = builder.get_object("loginsure")
    loginsure.connect('clicked',login_sure)

    logincancel = builder.get_object("logincancel")
    logincancel.connect('clicked',login_cancel)
    
    logind.show_all()
    namentry.show()
    pwdentry.show()

    #iconview2 for get share_name of remote share project or get&show the list of share file        
def iconview2_selection_changed(iconview2) :
    print "function::iconview2_selection_changed()"
    global current_remote_project
    iv2model = iconview2.get_model()
    path = iconview2.get_selected_items()[0]
    current_remote_project = iv2model[path][0]
    print current_remote_project

def iconview2_item_activated(iconview2, item) :
    print "function::iconview2_item_activated(i,i)"
    global mnt_list,name,pwd
    iv2model = iconview2.get_model()
    remote_project = iv2model[item][0]
#    print remote_project
    mnt_dir = fsop.browse_remote_share(current_node, remote_project,name,pwd)
    mnt_list.append(mnt_dir)



#quite
def quit(widget) :
    print "function::quite(w)"
    for mnt in mnt_list :
        umnt_cmd = 'umount '+mnt
        os.system(umnt_cmd)
    Gtk.main_quit()

#entry
if __name__ == '__main__' :
    init_all()
    Gtk.main()

